library platform_utils;

import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';

class PlatformUtils {
  static get({BuildContext context}) {
    return context != null ? Theme.of(context).platform : defaultTargetPlatform;
  }

  static select(
      {BuildContext context,
      dynamic android,
      dynamic ios,
      dynamic fuchsia,
      dynamic defaultWhenNull}) {
    var func;

    switch (get(context: context)) {
      case TargetPlatform.iOS:
        {
          func = ios;

          break;
        }

      case TargetPlatform.android:
        {
          func = android;

          break;
        }

      case TargetPlatform.fuchsia:
        {
          func = fuchsia;

          break;
        }
    }

    if (func is Function) {
      return func();
    }

    if (func == null && defaultWhenNull is Function) {
      return defaultWhenNull();
    }

    return func ?? defaultWhenNull;
  }
}
